(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/animations'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-animations', ['exports', '@angular/core', '@angular/common', '@angular/animations', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-animations'] = {}, global.ng.core, global.ng.common, global.ng.animations, global.rxjs));
}(this, (function (exports, core, common, animations$1, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var fadeIn = {
        denominator: 1,
        start: { opacity: '0' },
        steps: [{ opacity: '1' }]
    };
    var fadeInDown = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(0, -100%, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInDownBig = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(0, -2000px, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInLeft = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(-100%, 0, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInLeftBig = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(-2000px, 0, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInRight = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(100%, 0, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInRightBig = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(2000px, 0, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInUp = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(0, 100%, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };
    var fadeInUpBig = {
        denominator: 1,
        start: { opacity: '0', transform: 'translate3d(0, 2000px, 0' },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0' }]
    };

    var fadeOut = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0' }]
    };
    var fadeOutDown = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(0, 100%, 0' }]
    };
    var fadeOutDownBig = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(0, 2000px, 0' }]
    };
    var fadeOutLeft = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(-100%, 0, 0' }]
    };
    var fadeOutLeftBig = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(-2000px, 0, 0' }]
    };
    var fadeOutRight = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(100%, 0, 0' }]
    };
    var fadeOutRightBig = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(2000px, 0, 0' }]
    };
    var fadeOutUp = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(0, -100%, 0' }]
    };
    var fadeOutUpBig = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(0, -2000px, 0' }]
    };

    var bounceIn = {
        denominator: 5,
        start: { opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)', offset: 0 },
        steps: [
            { transform: 'scale3d(1.1, 1.1, 1.1)', offset: 0.2 },
            { transform: 'scale3d(0.9, 0.9, 0.9)', offset: 0.4 },
            { opacity: '1', transform: 'scale3d(1.03, 1.03, 1.03)', offset: 0.6 },
            { transform: 'scale3d(0.97, 0.97, 0.97)', offset: 0.8 },
            { opacity: '1', transform: 'scale3d(1, 1, 1)' }
        ]
    };
    var bounceInDown = {
        denominator: 4,
        start: { opacity: '0', transform: 'translate3d(0, -3000px, 0)', offset: 0 },
        steps: [
            { opacity: '1', transform: 'translate3d(0, 25px, 0)', offset: 0.6 },
            { transform: 'translate3d(0, -10px, 0)', offset: 0.75 },
            { transform: 'translate3d(0, 5px, 0)', offset: 0.9 },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };
    var bounceInLeft = {
        denominator: 4,
        start: { opacity: '0', transform: 'translate3d(-3000px, 0, 0)', offset: 0 },
        steps: [
            { opacity: '1', transform: 'translate3d(25px, 0, 0)', offset: 0.6 },
            { transform: 'translate3d(-10px, 0, 0)', offset: 0.75 },
            { transform: 'translate3d(5px, 0, 0)', offset: 0.9 },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };
    var bounceInRight = {
        denominator: 4,
        start: { opacity: '0', transform: 'translate3d(3000px, 0, 0)', offset: 0 },
        steps: [
            { opacity: '1', transform: 'translate3d(-25px, 0, 0)', offset: 0.6 },
            { transform: 'translate3d(10px, 0, 0)', offset: 0.75 },
            { transform: 'translate3d(-5px, 0, 0)', offset: 0.9 },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };
    var bounceInUp = {
        denominator: 4,
        start: { opacity: '0', transform: 'translate3d(0, 3000px, 0)', offset: 0 },
        steps: [
            { opacity: '1', transform: 'translate3d(0, -25px, 0)', offset: 0.6 },
            { transform: 'translate3d(0, 10px, 0)', offset: 0.75 },
            { transform: 'translate3d(0, -5px, 0)', offset: 0.9 },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };

    var bounceOut = {
        denominator: 3,
        start: {},
        steps: [
            { transform: 'scale3d(0.9, 0.9, 0.9', offset: 0.2 },
            { opacity: 1, transform: 'scale3d(1.1, 1.1, 1.1', offset: 0.55 },
            { opacity: 0, transform: 'scale3d(0.3, 0.3, 0.3' }
        ]
    };
    var bounceOutDown = {
        denominator: 3,
        start: {},
        steps: [
            { transform: 'translate3d(0, 10px, 0', offset: 0.2 },
            { opacity: 1, transform: 'translate3d(0, -20px, 0', offset: 0.45 },
            { opacity: 0, transform: 'translate3d(0, 2000px, 0' }
        ]
    };
    var bounceOutLeft = {
        denominator: 2,
        start: {},
        steps: [
            { opacity: 1, transform: 'translate3d(20px, 0, 0', offset: 0.2 },
            { opacity: 0, transform: 'translate3d(-2000px, 0, 0' }
        ]
    };
    var bounceOutRight = {
        denominator: 2,
        start: {},
        steps: [
            { opacity: 1, transform: 'translate3d(-20px, 0, 0', offset: 0.2 },
            { opacity: 0, transform: 'translate3d(2000px, 0, 0' }
        ]
    };
    var bounceOutUp = {
        denominator: 3,
        start: {},
        steps: [
            { transform: 'translate3d(0, -10px, 0', offset: 0.2 },
            { opacity: 1, transform: 'translate3d(0, 20px, 0', offset: 0.45 },
            { opacity: 0, transform: 'translate3d(0, -2000px, 0' }
        ]
    };

    var bounce = {
        denominator: 4,
        start: {},
        steps: [
            {
                transform: 'translate3d(0, -30px, 0)',
                'animation-timing-function': 'cubic-bezier(0.755, 0.05, 0.855, 0.06)',
                offset: 0.43
            },
            {
                transform: 'translate3d(0, -15px, 0)',
                'animation-timing-function': 'cubic-bezier(0.755, 0.05, 0.855, 0.06)',
                offset: 0.7
            },
            {
                transform: 'translate3d(0, -4px, 0)',
                offset: 0.9
            },
            {
                'animation-timing-function': 'cubic-bezier(0.215, 0.61, 0.355, 1)',
                transform: 'translate3d(0, 0, 0)',
                offset: 1
            }
        ]
    };
    var flash = {
        denominator: 4,
        start: { opacity: '1', offset: 0 },
        steps: [
            { opacity: '0', offset: 0.25 },
            { opacity: '1', offset: 0.5 },
            { opacity: '0', offset: 0.75 },
            { opacity: '1', offset: 1 }
        ]
    };
    var headShake = {
        denominator: 5,
        start: { transform: 'translateX(0)', offset: 0 },
        steps: [
            { transform: 'translateX(-6px) rotateY(-9deg)', offset: 0.06 },
            { transform: 'translateX(5px) rotateY(7deg)', offset: 0.18 },
            { transform: 'translateX(-3px) rotateY(-5deg)', offset: 0.31 },
            { transform: 'translateX(2px) rotateY(3deg)', offset: 0.43 },
            { transform: 'translateX(0)', offset: 0.5 }
        ]
    };
    var heartBeat = {
        denominator: 5,
        start: { transform: 'scale(1)', offset: 0 },
        steps: [
            { transform: 'scale(1.3)', offset: 0.14 },
            { transform: 'scale(1)', offset: 0.28 },
            { transform: 'scale(1.3)', offset: 0.42 },
            { transform: 'scale(1)', offset: 0.7 }
        ]
    };
    var jello = {
        denominator: 7,
        start: { transform: 'translate3d(0, 0, 0)', offset: 0 },
        steps: [
            { transform: 'skewX(-12.5deg) skewY(-12.5deg)', offset: 0.22 },
            { transform: 'skewX(6.25deg) skewY(6.25deg)', offset: 0.33 },
            { transform: 'skewX(-3.125deg) skewY(-3.125deg)', offset: 0.44 },
            { transform: 'skewX(1.5625deg) skewY(1.5625deg)', offset: 0.55 },
            {
                transform: 'skewX(-0.78125deg) skewY(-0.78125deg)',
                offset: 0.66
            },
            {
                transform: 'skewX(0.390625deg) skewY(0.390625deg)',
                offset: 0.77
            },
            {
                transform: 'skewX(-0.1953125deg) skewY(-0.1953125deg)',
                offset: 0.88
            }
        ]
    };
    var pulse = {
        denominator: 2,
        start: { transform: 'scale3d(1, 1, 1)', offset: 0 },
        steps: [
            { transform: 'scale3d(1.05, 1.05, 1.05)', offset: 0.5 },
            { transform: 'scale3d(1, 1, 1)', offset: 1 }
        ]
    };
    var rubberBand = {
        denominator: 6,
        start: { transform: 'scale3d(1, 1, 1)', offset: 0 },
        steps: [
            { transform: 'scale3d(1.25, 0.75, 1)', offset: 0.3 },
            { transform: 'scale3d(0.75, 1.25, 1)', offset: 0.4 },
            { transform: 'scale3d(1.15, 0.85, 1)', offset: 0.5 },
            { transform: 'scale3d(0.95, 1.05, 1)', offset: 0.65 },
            { transform: 'scale3d(1.05, 0.95, 1)', offset: 0.75 },
            { transform: 'scale3d(1, 1, 1)', offset: 1 }
        ]
    };
    var shake = {
        denominator: 10,
        start: { transform: 'translate3d(0, 0, 0)', offset: 0 },
        steps: [
            { transform: 'translate3d(-10px, 0, 0)' },
            { transform: 'translate3d( 10px, 0, 0)' },
            { transform: 'translate3d(-10px, 0, 0)' },
            { transform: 'translate3d( 10px, 0, 0)' },
            { transform: 'translate3d(-10px, 0, 0)' },
            { transform: 'translate3d( 10px, 0, 0)' },
            { transform: 'translate3d(-10px, 0, 0)' },
            { transform: 'translate3d( 10px, 0, 0)' },
            { transform: 'translate3d(-10px, 0, 0)' },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };
    var swing = {
        denominator: 10,
        start: {},
        steps: [
            { transform: 'rotate3d(0, 0, 1, 15deg)' },
            { transform: 'rotate3d(0, 0, 1, -10deg)' },
            { transform: 'rotate3d(0, 0, 1, 5deg)' },
            { transform: 'rotate3d(0, 0, 1, -5deg)' },
            { transform: 'rotate3d(0, 0, 1, 0deg)' }
        ]
    };
    var tada = {
        denominator: 10,
        start: { transform: 'scale3d(1, 1, 1)' },
        steps: [
            { transform: 'scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'scale3d(0.9, 0.9, 0.9) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'scale3d(1.1, 1.1, 1.1) rotate3d(0, 0, 1, 3deg)' },
            { transform: 'scale3d(1, 1, 1)' }
        ]
    };
    var wobble = {
        denominator: 6,
        start: { transform: 'translate3d(0, 0, 0)' },
        steps: [
            { transform: 'translate3d(-25%, 0, 0) rotate3d(0, 0, 1, -5deg)' },
            { transform: 'translate3d(20%, 0, 0) rotate3d(0, 0, 1, 3deg)' },
            { transform: 'translate3d(-15%, 0, 0) rotate3d(0, 0, 1, -3deg)' },
            { transform: 'translate3d(10%, 0, 0) rotate3d(0, 0, 1, 2deg)' },
            { transform: 'translate3d(-5%, 0, 0) rotate3d(0, 0, 1, -1deg)' },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };

    var flip = {
        denominator: 4,
        start: {
            transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 0) rotate3d(0, 1, 0, -360deg)'
        },
        steps: [
            {
                transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 150px) rotate3d(0, 1, 0, -190deg)'
            },
            {
                transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 150px) rotate3d(0, 1, 0, -170deg)'
            },
            {
                transform: 'perspective(400px) scale3d(0.95, 0.95, 0.95) translate3d(0, 0, 0) rotate3d(0, 1, 0, 0deg)'
            },
            {
                transform: 'perspective(400px) scale3d(1, 1, 1) translate3d(0, 0, 0) rotate3d(0, 1, 0, 0deg)'
            }
        ]
    };
    var flipInX = {
        denominator: 4,
        start: { transform: 'perspective(400px) rotate3d(1, 0, 0, 90deg)' },
        steps: [
            { transform: 'perspective(400px) rotate3d(1, 0, 0, -20deg)' },
            { transform: 'perspective(400px) rotate3d(1, 0, 0, 10deg)' },
            { transform: 'perspective(400px) rotate3d(1, 0, 0, -5deg)' },
            { transform: 'perspective(400px)' }
        ]
    };
    var flipInY = {
        denominator: 4,
        start: { transform: 'perspective(400px) rotate3d(0, 1, 0, 90deg)' },
        steps: [
            { transform: 'perspective(400px) rotate3d(0, 1, 0, -20deg)' },
            { transform: 'perspective(400px) rotate3d(0, 1, 0, 10deg)' },
            { transform: 'perspective(400px) rotate3d(0, 1, 0, -5deg)' },
            { transform: 'perspective(400px)' }
        ]
    };
    var flipOutX = {
        denominator: 2,
        start: { transform: 'perspective(400px)' },
        steps: [
            { transform: 'perspective(400px) rotate3d(1, 0, 0, -20deg)' },
            { opacity: 0, transform: 'perspective(400px) rotate3d(1, 0, 0, 90deg)' }
        ]
    };
    var flipOutY = {
        denominator: 2,
        start: { transform: 'perspective(400px)' },
        steps: [
            { transform: 'perspective(400px) rotate3d(0, 1, 0, -15deg)' },
            { opacity: 0, transform: 'perspective(400px) rotate3d(0, 1, 0, 90deg)' }
        ]
    };

    var lightSpeedIn = {
        denominator: 4,
        start: { opacity: '0', transform: 'translate3d(100%, 0, 0) skewX(-30deg)' },
        steps: [
            { opacity: '1', transform: 'skewX(20deg)', offset: 0.6 },
            { transform: 'skewX(-5deg)', offset: 0.8 },
            { transform: 'translate3d(0, 0, 0)' }
        ]
    };
    var lightSpeedOut = {
        denominator: 4,
        start: { opacity: '1' },
        steps: [{ opacity: '0', transform: 'translate3d(100%, 0, 0) skewX(30deg)' }]
    };

    var rotateIn = {
        denominator: 2,
        start: {
            opacity: '0',
            'transform-origin': 'center',
            transform: 'rotate3d(0, 0, 1, -200deg)'
        },
        steps: [
            {
                opacity: '1',
                'transform-origin': 'center',
                transform: 'translate3d(0, 0, 0)'
            }
        ]
    };
    var rotateInDownLeft = {
        denominator: 2,
        start: {
            opacity: '0',
            'transform-origin': 'left bottom',
            transform: 'rotate3d(0, 0, 1, -45deg)'
        },
        steps: [
            {
                opacity: '1',
                'transform-origin': 'left bottom',
                transform: 'translate3d(0, 0, 0)'
            }
        ]
    };
    var rotateInDownRight = {
        denominator: 2,
        start: {
            opacity: '0',
            'transform-origin': 'right bottom',
            transform: 'rotate3d(0, 0, 1, 45deg)'
        },
        steps: [
            {
                opacity: '1',
                'transform-origin': 'right bottom',
                transform: 'translate3d(0, 0, 0)'
            }
        ]
    };
    var rotateInUpLeft = {
        denominator: 2,
        start: {
            opacity: '0',
            'transform-origin': 'left bottom',
            transform: 'rotate3d(0, 0, 1, 45deg)'
        },
        steps: [
            {
                opacity: '1',
                'transform-origin': 'left bottom',
                transform: 'translate3d(0, 0, 0)'
            }
        ]
    };
    var rotateInUpRight = {
        denominator: 2,
        start: {
            opacity: '0',
            'transform-origin': 'right bottom',
            transform: 'rotate3d(0, 0, 1, -90deg)'
        },
        steps: [
            {
                opacity: '1',
                'transform-origin': 'right bottom',
                transform: 'translate3d(0, 0, 0)'
            }
        ]
    };

    var rotateOut = {
        denominator: 2,
        start: { opacity: '1', 'transform-origin': 'center' },
        steps: [
            {
                opacity: '0',
                'transform-origin': 'center',
                transform: 'rotate3d(0, 0, 1, 200deg'
            }
        ]
    };
    var rotateOutDownLeft = {
        denominator: 2,
        start: { opacity: '1', 'transform-origin': 'left bottom' },
        steps: [
            {
                opacity: '0',
                'transform-origin': 'left bottom',
                transform: 'rotate3d(0, 0, 1, 45deg'
            }
        ]
    };
    var rotateOutDownRight = {
        denominator: 2,
        start: { opacity: '1', 'transform-origin': 'right bottom' },
        steps: [
            {
                opacity: '0',
                'transform-origin': 'right bottom',
                transform: 'rotate3d(0, 0, 1, -45deg'
            }
        ]
    };
    var rotateOutUpLeft = {
        denominator: 2,
        start: { opacity: '1', 'transform-origin': 'left bottom' },
        steps: [
            {
                opacity: '0',
                'transform-origin': 'left bottom',
                transform: 'rotate3d(0, 0, 1, -45deg'
            }
        ]
    };
    var rotateOutUpRight = {
        denominator: 2,
        start: { opacity: '1', 'transform-origin': 'right bottom' },
        steps: [
            {
                opacity: '0',
                'transform-origin': 'right bottom',
                transform: 'rotate3d(0, 0, 1, 90deg'
            }
        ]
    };

    var slideInDown = {
        denominator: 2,
        start: { visibility: 'visible', transform: 'translate3d(0, -100%, 0' },
        steps: [{ transform: 'translate3d(0, 0, 0' }]
    };
    var slideInLeft = {
        denominator: 2,
        start: { visibility: 'visible', transform: 'translate3d(-100%, 0, 0' },
        steps: [{ transform: 'translate3d(0, 0, 0' }]
    };
    var slideInRight = {
        denominator: 2,
        start: { visibility: 'visible', transform: 'translate3d(100%, 0, 0' },
        steps: [{ transform: 'translate3d(0, 0, 0' }]
    };
    var slideInUp = {
        denominator: 2,
        start: { visibility: 'visible', transform: 'translate3d(0, 100%, 0' },
        steps: [{ transform: 'translate3d(0, 0, 0' }]
    };

    var slideOutDown = {
        denominator: 2,
        start: { transform: 'translate3d(0, 0, 0' },
        steps: [{ visibility: 'hidden', transform: 'translate3d(0, 100%, 0' }]
    };
    var slideOutLeft = {
        denominator: 2,
        start: { transform: 'translate3d(0, 0, 0' },
        steps: [{ visibility: 'hidden', transform: 'translate3d(-100%, 0, 0' }]
    };
    var slideOutRight = {
        denominator: 2,
        start: { transform: 'translate3d(0, 0, 0' },
        steps: [{ visibility: 'hidden', transform: 'translate3d(100%, 0, 0' }]
    };
    var slideOutUp = {
        denominator: 2,
        start: { transform: 'translate3d(0, 0, 0' },
        steps: [{ visibility: 'hidden', transform: 'translate3d(0, -100%, 0' }]
    };

    var hinge = {
        denominator: 3,
        start: {
            'transform-origin': 'top left',
            'animation-timing-function': 'ease-in-out'
        },
        steps: [
            {
                'transform-origin': 'top left',
                'animation-timing-function': 'ease-in-out',
                transform: 'rotate3d(0, 0, 1, 80deg)'
            },
            {
                opacity: '1',
                'transform-origin': 'top left',
                'animation-timing-function': 'ease-in-out',
                transform: 'rotate3d(0, 0, 1, 60deg)'
            },
            {
                opacity: '0',
                'transform-origin': 'top left',
                'animation-timing-function': 'ease-in-out',
                transform: 'translate3d(0, 700px, 0)'
            }
        ]
    };
    var jackInTheBox = {
        denominator: 3,
        start: {
            opacity: '0',
            'transform-origin': 'center bottom',
            transform: 'scale(0.1) rotate(30deg)'
        },
        steps: [
            { transform: 'rotate(-10deg)' },
            { transform: 'rotate(3deg)' },
            { opacity: '1', transform: 'scale(1)' }
        ]
    };
    var rollIn = {
        denominator: 1,
        start: {
            opacity: '0',
            transform: 'translate3d(-100%, 0, 0) rotate3d(0, 0, 1, -120deg)'
        },
        steps: [{ opacity: '1', transform: 'translate3d(0, 0, 0)' }]
    };
    var rollOut = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [
            {
                opacity: '0',
                transform: 'translate3d(100%, 0, 0) rotate3d(0, 0, 1, 120deg)'
            }
        ]
    };

    var zoomIn = {
        denominator: 1,
        start: { opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)' },
        steps: [{ opacity: '1', transform: 'scale3d(1, 1, 1)' }]
    };
    var zoomInDown = {
        denominator: 1,
        start: {
            opacity: '0',
            transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, -1000px, 0)',
            'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
        },
        steps: [
            {
                opacity: '1',
                transform: 'scale3d(1, 1, 1) translate3d(0, 0, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };
    var zoomInLeft = {
        denominator: 1,
        start: {
            opacity: '0',
            transform: 'scale3d(0.1, 0.1, 0.1) translate3d(-1000px, 0, 0)',
            'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
        },
        steps: [
            {
                opacity: '1',
                transform: 'scale3d(1, 1, 1) translate3d(0, 0, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };
    var zoomInRight = {
        denominator: 1,
        start: {
            opacity: '0',
            transform: 'scale3d(0.1, 0.1, 0.1) translate3d(1000px, 0, 0)',
            'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
        },
        steps: [
            {
                opacity: '1',
                transform: 'scale3d(1, 1, 1) translate3d(0, 0, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };
    var zoomInUp = {
        denominator: 1,
        start: {
            opacity: '0',
            transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, 1000px, 0)',
            'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)'
        },
        steps: [
            {
                opacity: '1',
                transform: 'scale3d(1, 1, 1) translate3d(0, 0, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };

    var zoomOut = {
        denominator: 1,
        start: { opacity: '1' },
        steps: [
            { opacity: '0', transform: 'scale3d(0.3, 0.3, 0.3)', offset: 0.5 },
            { opacity: '0' }
        ]
    };
    var zoomOutDown = {
        denominator: 1,
        start: {},
        steps: [
            {
                opacity: '0.5',
                transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, 0, 0)',
                'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)',
                offset: 0.4
            },
            {
                opacity: '0',
                'transform-origin': 'center bottom',
                transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, 2000px, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };
    var zoomOutLeft = {
        denominator: 1,
        start: {},
        steps: [
            {
                opacity: '0.5',
                transform: 'scale3d(0.475, 0.475, 0.475) translate3d(42px, 0, 0)',
                offset: 0.4
            },
            {
                opacity: '0',
                'transform-origin': 'left center',
                transform: 'scale(0.1) translate3d(-2000px, 0, 0)'
            }
        ]
    };
    var zoomOutRight = {
        denominator: 1,
        start: {},
        steps: [
            {
                opacity: '0.5',
                transform: 'scale3d(0.475, 0.475, 0.475) translate3d(-42px, 0, 0)',
                offset: 0.4
            },
            {
                opacity: '0',
                'transform-origin': 'right center',
                transform: 'scale(0.1) translate3d(2000px, 0, 0)'
            }
        ]
    };
    var zoomOutUp = {
        denominator: 1,
        start: {},
        steps: [
            {
                opacity: '0.5',
                transform: 'scale3d(0.475, 0.475, 0.475) translate3d(0, 60px, 0)',
                'animation-timing-function': 'cubic-bezier(0.55, 0.055, 0.675, 0.19)',
                offset: 0.4
            },
            {
                opacity: '0',
                'transform-origin': 'center bottom',
                transform: 'scale3d(0.1, 0.1, 0.1) translate3d(0, -2000px, 0)',
                'animation-timing-function': 'cubic-bezier(0.175, 0.885, 0.32, 1)'
            }
        ]
    };

    var backInDown = {
        denominator: 1,
        start: { opacity: '0.7', transform: 'translateY(-1200px) scale(0.7)' },
        steps: [
            { opacity: '0.7', transform: 'translateY(0px) scale(0.7)', offset: 0.8 },
            { opacity: '1', transform: 'scale(1)', offset: 1 }
        ]
    };
    var backInLeft = {
        denominator: 1,
        start: { opacity: '0.7', transform: 'translateX(-2000px) scale(0.7)' },
        steps: [
            { opacity: '0.7', transform: 'translateX(0px) scale(0.7)', offset: 0.8 },
            { opacity: '1', transform: 'scale(1)', offset: 1 }
        ]
    };
    var backInRight = {
        denominator: 1,
        start: { opacity: '0.7', transform: 'translateX(2000px) scale(0.7)' },
        steps: [
            { opacity: '0.7', transform: 'translateX(0px) scale(0.7)', offset: 0.8 },
            { opacity: '1', transform: 'scale(1)', offset: 1 }
        ]
    };
    var backInUp = {
        denominator: 1,
        start: { opacity: '0.7', transform: 'translateY(1200px) scale(0.7)' },
        steps: [
            { opacity: '0.7', transform: 'translateY(0px) scale(0.7)', offset: 0.8 },
            { opacity: '1', transform: 'scale(1)', offset: 1 }
        ]
    };

    var backOutDown = {
        denominator: 1,
        start: { opacity: '1', transform: 'scale(1)' },
        steps: [
            { opacity: '0.7', transform: 'translateY(0px) scale(0.7)', offset: 0.2 },
            { opacity: '0.7', transform: 'translateY(700px) scale(0.7)', offset: 1 }
        ]
    };
    var backOutLeft = {
        denominator: 1,
        start: { opacity: '1', transform: 'scale(1)' },
        steps: [
            { opacity: '0.7', transform: 'translateX(0px) scale(0.7)', offset: 0.2 },
            { opacity: '0.7', transform: 'translateX(-2000px) scale(0.7)', offset: 1 }
        ]
    };
    var backOutRight = {
        denominator: 1,
        start: { opacity: '1', transform: 'scale(1)' },
        steps: [
            { opacity: '0.7', transform: 'translateX(0px) scale(0.7)', offset: 0.2 },
            { opacity: '0.7', transform: 'translateX(2000px) scale(0.7)', offset: 1 }
        ]
    };
    var backOutUp = {
        denominator: 1,
        start: { opacity: '1', transform: 'scale(1)' },
        steps: [
            { opacity: '0.7', transform: 'translateY(0px) scale(0.7)', offset: 0.2 },
            { opacity: '0.7', transform: 'translateY(-700px) scale(0.7)', offset: 1 }
        ]
    };

    function stylesToAnimation(animationDefinition) {
        return function (time) { return __spread([
            animations$1.style(animationDefinition.start)
        ], animationDefinition.steps.map(function (_) { return animations$1.animate(time / animationDefinition.denominator, animations$1.style(_)); })); };
    }
    var animations = {
        bounce: stylesToAnimation(bounce),
        flash: stylesToAnimation(flash),
        headShake: stylesToAnimation(headShake),
        heartBeat: stylesToAnimation(heartBeat),
        pulse: stylesToAnimation(pulse),
        rubberBand: stylesToAnimation(rubberBand),
        shake: stylesToAnimation(shake),
        swing: stylesToAnimation(swing),
        tada: stylesToAnimation(tada),
        wobble: stylesToAnimation(wobble),
        jello: stylesToAnimation(jello),
        bounceIn: stylesToAnimation(bounceIn),
        bounceInDown: stylesToAnimation(bounceInDown),
        bounceInLeft: stylesToAnimation(bounceInLeft),
        bounceInRight: stylesToAnimation(bounceInRight),
        bounceInUp: stylesToAnimation(bounceInUp),
        bounceOut: stylesToAnimation(bounceOut),
        bounceOutDown: stylesToAnimation(bounceOutDown),
        bounceOutLeft: stylesToAnimation(bounceOutLeft),
        bounceOutRight: stylesToAnimation(bounceOutRight),
        bounceOutUp: stylesToAnimation(bounceOutUp),
        fadeIn: stylesToAnimation(fadeIn),
        fadeInDown: stylesToAnimation(fadeInDown),
        fadeInDownBig: stylesToAnimation(fadeInDownBig),
        fadeInLeft: stylesToAnimation(fadeInLeft),
        fadeInLeftBig: stylesToAnimation(fadeInLeftBig),
        fadeInRight: stylesToAnimation(fadeInRight),
        fadeInRightBig: stylesToAnimation(fadeInRightBig),
        fadeInUp: stylesToAnimation(fadeInUp),
        fadeInUpBig: stylesToAnimation(fadeInUpBig),
        fadeOut: stylesToAnimation(fadeOut),
        fadeOutDown: stylesToAnimation(fadeOutDown),
        fadeOutDownBig: stylesToAnimation(fadeOutDownBig),
        fadeOutLeft: stylesToAnimation(fadeOutLeft),
        fadeOutLeftBig: stylesToAnimation(fadeOutLeftBig),
        fadeOutRight: stylesToAnimation(fadeOutRight),
        fadeOutRightBig: stylesToAnimation(fadeOutRightBig),
        fadeOutUp: stylesToAnimation(fadeOutUp),
        fadeOutUpBig: stylesToAnimation(fadeOutUpBig),
        flip: stylesToAnimation(flip),
        flipInX: stylesToAnimation(flipInX),
        flipInY: stylesToAnimation(flipInY),
        flipOutX: stylesToAnimation(flipOutX),
        flipOutY: stylesToAnimation(flipOutY),
        lightSpeedIn: stylesToAnimation(lightSpeedIn),
        lightSpeedOut: stylesToAnimation(lightSpeedOut),
        rotateIn: stylesToAnimation(rotateIn),
        rotateInDownLeft: stylesToAnimation(rotateInDownLeft),
        rotateInDownRight: stylesToAnimation(rotateInDownRight),
        rotateInUpLeft: stylesToAnimation(rotateInUpLeft),
        rotateInUpRight: stylesToAnimation(rotateInUpRight),
        rotateOut: stylesToAnimation(rotateOut),
        rotateOutDownLeft: stylesToAnimation(rotateOutDownLeft),
        rotateOutDownRight: stylesToAnimation(rotateOutDownRight),
        rotateOutUpLeft: stylesToAnimation(rotateOutUpLeft),
        rotateOutUpRight: stylesToAnimation(rotateOutUpRight),
        slideInUp: stylesToAnimation(slideInUp),
        slideInDown: stylesToAnimation(slideInDown),
        slideInLeft: stylesToAnimation(slideInLeft),
        slideInRight: stylesToAnimation(slideInRight),
        slideOutUp: stylesToAnimation(slideOutUp),
        slideOutDown: stylesToAnimation(slideOutDown),
        slideOutLeft: stylesToAnimation(slideOutLeft),
        slideOutRight: stylesToAnimation(slideOutRight),
        zoomIn: stylesToAnimation(zoomIn),
        zoomInDown: stylesToAnimation(zoomInDown),
        zoomInLeft: stylesToAnimation(zoomInLeft),
        zoomInRight: stylesToAnimation(zoomInRight),
        zoomInUp: stylesToAnimation(zoomInUp),
        zoomOut: stylesToAnimation(zoomOut),
        zoomOutDown: stylesToAnimation(zoomOutDown),
        zoomOutLeft: stylesToAnimation(zoomOutLeft),
        zoomOutRight: stylesToAnimation(zoomOutRight),
        zoomOutUp: stylesToAnimation(zoomOutUp),
        hinge: stylesToAnimation(hinge),
        jackInTheBox: stylesToAnimation(jackInTheBox),
        rollIn: stylesToAnimation(rollIn),
        rollOut: stylesToAnimation(rollOut),
        backInDown: stylesToAnimation(backInDown),
        backInLeft: stylesToAnimation(backInLeft),
        backInRight: stylesToAnimation(backInRight),
        backInUp: stylesToAnimation(backInUp),
        backOutDown: stylesToAnimation(backOutDown),
        backOutLeft: stylesToAnimation(backOutLeft),
        backOutRight: stylesToAnimation(backOutRight),
        backOutUp: stylesToAnimation(backOutUp)
    };

    var AnimationsService = /** @class */ (function () {
        function AnimationsService(_builder) {
            this._builder = _builder;
            this.animations = animations;
        }
        AnimationsService.prototype.create = function (animation, element) {
            return this._builder.build(animation).create(element);
        };
        AnimationsService.prototype.addAnimations = function (customAnimations) {
            var _this = this;
            customAnimations.forEach(function (animation) { return _this.add(animation.name, animation.animation); });
        };
        AnimationsService.prototype.add = function (name, animation) {
            if (this.animations[name] !== undefined) {
                throw new Error('There is already an animation named ' + name);
            }
            this.animations[name] = stylesToAnimation(animation);
        };
        return AnimationsService;
    }());
    AnimationsService.decorators = [
        { type: core.Injectable }
    ];
    AnimationsService.ctorParameters = function () { return [
        { type: animations$1.AnimationBuilder }
    ]; };

    var AnimIfDirective = /** @class */ (function () {
        function AnimIfDirective(templateRef, viewContainer, _animationsService) {
            this.templateRef = templateRef;
            this.viewContainer = viewContainer;
            this._animationsService = _animationsService;
            this.shownBefore = false;
        }
        Object.defineProperty(AnimIfDirective.prototype, "animIf", {
            set: function (show) {
                this.show = show;
                this._animIfDirty = true;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Applies the changes when needed.
         */
        AnimIfDirective.prototype.ngDoCheck = function () {
            if (this._animIfDirty) {
                this._animIfDirty = false;
                if (this.subscription) {
                    this.subscription.unsubscribe();
                }
                if (this.show && !this.shownBefore) {
                    this.viewContainer.clear();
                    this.viewContainer.createEmbeddedView(this.templateRef);
                    var player = this.createPlayer(this.animIfInfo.startAnim, this.animIfInfo.time);
                    player.play();
                    this.shownBefore = true;
                }
                if (!this.show && this.shownBefore) {
                    var player = this.createPlayer(this.animIfInfo.endAnim, this.animIfInfo.time);
                    player.play();
                    this.clearAfterTime(this.viewContainer, this.animIfInfo.time);
                    this.shownBefore = false;
                }
            }
        };
        AnimIfDirective.prototype.createPlayer = function (animation, time) {
            return this._animationsService.create(this._animationsService.animations[animation](time), this.viewContainer.get(0).rootNodes[0]);
        };
        AnimIfDirective.prototype.clearAfterTime = function (viewContainer, time) {
            this.subscription = rxjs.timer(time).subscribe(function () {
                viewContainer.clear();
            });
        };
        return AnimIfDirective;
    }());
    AnimIfDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[animIf]'
                },] }
    ];
    AnimIfDirective.ctorParameters = function () { return [
        { type: core.TemplateRef },
        { type: core.ViewContainerRef },
        { type: AnimationsService }
    ]; };
    AnimIfDirective.propDecorators = {
        animIfInfo: [{ type: core.Input }],
        animIf: [{ type: core.Input }]
    };

    var AnimatedDirective = /** @class */ (function () {
        function AnimatedDirective(el, _animationsService) {
            this.el = el;
            this._animationsService = _animationsService;
            this.time = 300;
            this.animation = 'fadeIn';
        }
        Object.defineProperty(AnimatedDirective.prototype, "animAted", {
            set: function (options) {
                if (options) {
                    this.time = options.time || this.time;
                    this.animation = options.animation || this.animation;
                }
            },
            enumerable: false,
            configurable: true
        });
        AnimatedDirective.prototype.animate = function (options) {
            var _this = this;
            var player;
            if (options !== undefined) {
                player = this.createPlayer(options.animation || this.animation, options.time || this.time);
            }
            else {
                player = this.createPlayer(this.animation, this.time);
            }
            player.play();
            player.onDone(function () { return __awaiter(_this, void 0, void 0, function () {
                var time;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            time = options !== undefined ? options.time || this.time : this.time;
                            return [4 /*yield*/, rxjs.timer(time).toPromise()];
                        case 1:
                            _a.sent();
                            player.reset();
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        AnimatedDirective.prototype.createPlayer = function (animation, time) {
            return this._animationsService.create(this._animationsService.animations[animation](time), this.el.nativeElement);
        };
        return AnimatedDirective;
    }());
    AnimatedDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[animAted]',
                    exportAs: 'animated'
                },] }
    ];
    AnimatedDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: AnimationsService }
    ]; };
    AnimatedDirective.propDecorators = {
        animAted: [{ type: core.Input }]
    };

    var NgxAnimationsModule = /** @class */ (function () {
        function NgxAnimationsModule() {
        }
        return NgxAnimationsModule;
    }());
    NgxAnimationsModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [AnimIfDirective, AnimatedDirective],
                    imports: [common.CommonModule],
                    providers: [AnimationsService],
                    exports: [AnimIfDirective, AnimatedDirective]
                },] }
    ];

    var AnimationDefinition = /** @class */ (function () {
        function AnimationDefinition(start, steps, denominator) {
            if (denominator === void 0) { denominator = 1; }
            this.start = start;
            this.steps = steps;
            this.denominator = denominator;
        }
        return AnimationDefinition;
    }());

    /*
     * Build route transition that can be used in the @Component animations
     * Usage Example :
     * @Component({
     *   selector: 'my-app',
     *   templateUrl: './app.component.html',
     *   styleUrls: ['./app.component.css'],
     *   animations: [
     *    buildRouteTransition({ stateChangeExpr: '* => *',
     *     enter: animations.bounceIn(200),
     *     leave: animations.bounceOut(200)})
     *   ]
     * })
     */
    function buildRouteTransition(options) {
        if (options === void 0) { options = {}; }
        return animations$1.transition(options.stateChangeExpr || '* => *', [
            animations$1.query(':enter', [animations$1.style({ opacity: 0, position: 'absolute' })], { optional: true }),
            animations$1.query(':leave', __spread([animations$1.style({ position: 'absolute' })], (options.leave || animations.bounceOut(200))), {
                optional: true
            }),
            animations$1.query(':enter', __spread([animations$1.style({ position: 'absolute' })], (options.enter || animations.bounceIn(200))), {
                optional: true
            })
        ]);
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AnimIfDirective = AnimIfDirective;
    exports.AnimatedDirective = AnimatedDirective;
    exports.AnimationDefinition = AnimationDefinition;
    exports.AnimationsService = AnimationsService;
    exports.NgxAnimationsModule = NgxAnimationsModule;
    exports.animations = animations;
    exports.backInDown = backInDown;
    exports.backInLeft = backInLeft;
    exports.backInRight = backInRight;
    exports.backInUp = backInUp;
    exports.backOutDown = backOutDown;
    exports.backOutLeft = backOutLeft;
    exports.backOutRight = backOutRight;
    exports.backOutUp = backOutUp;
    exports.bounce = bounce;
    exports.bounceIn = bounceIn;
    exports.bounceInDown = bounceInDown;
    exports.bounceInLeft = bounceInLeft;
    exports.bounceInRight = bounceInRight;
    exports.bounceInUp = bounceInUp;
    exports.bounceOut = bounceOut;
    exports.bounceOutDown = bounceOutDown;
    exports.bounceOutLeft = bounceOutLeft;
    exports.bounceOutRight = bounceOutRight;
    exports.bounceOutUp = bounceOutUp;
    exports.buildRouteTransition = buildRouteTransition;
    exports.fadeIn = fadeIn;
    exports.fadeInDown = fadeInDown;
    exports.fadeInDownBig = fadeInDownBig;
    exports.fadeInLeft = fadeInLeft;
    exports.fadeInLeftBig = fadeInLeftBig;
    exports.fadeInRight = fadeInRight;
    exports.fadeInRightBig = fadeInRightBig;
    exports.fadeInUp = fadeInUp;
    exports.fadeInUpBig = fadeInUpBig;
    exports.fadeOut = fadeOut;
    exports.fadeOutDown = fadeOutDown;
    exports.fadeOutDownBig = fadeOutDownBig;
    exports.fadeOutLeft = fadeOutLeft;
    exports.fadeOutLeftBig = fadeOutLeftBig;
    exports.fadeOutRight = fadeOutRight;
    exports.fadeOutRightBig = fadeOutRightBig;
    exports.fadeOutUp = fadeOutUp;
    exports.fadeOutUpBig = fadeOutUpBig;
    exports.flash = flash;
    exports.flip = flip;
    exports.flipInX = flipInX;
    exports.flipInY = flipInY;
    exports.flipOutX = flipOutX;
    exports.flipOutY = flipOutY;
    exports.headShake = headShake;
    exports.heartBeat = heartBeat;
    exports.hinge = hinge;
    exports.jackInTheBox = jackInTheBox;
    exports.jello = jello;
    exports.lightSpeedIn = lightSpeedIn;
    exports.lightSpeedOut = lightSpeedOut;
    exports.pulse = pulse;
    exports.rollIn = rollIn;
    exports.rollOut = rollOut;
    exports.rotateIn = rotateIn;
    exports.rotateInDownLeft = rotateInDownLeft;
    exports.rotateInDownRight = rotateInDownRight;
    exports.rotateInUpLeft = rotateInUpLeft;
    exports.rotateInUpRight = rotateInUpRight;
    exports.rotateOut = rotateOut;
    exports.rotateOutDownLeft = rotateOutDownLeft;
    exports.rotateOutDownRight = rotateOutDownRight;
    exports.rotateOutUpLeft = rotateOutUpLeft;
    exports.rotateOutUpRight = rotateOutUpRight;
    exports.rubberBand = rubberBand;
    exports.shake = shake;
    exports.slideInDown = slideInDown;
    exports.slideInLeft = slideInLeft;
    exports.slideInRight = slideInRight;
    exports.slideInUp = slideInUp;
    exports.slideOutDown = slideOutDown;
    exports.slideOutLeft = slideOutLeft;
    exports.slideOutRight = slideOutRight;
    exports.slideOutUp = slideOutUp;
    exports.stylesToAnimation = stylesToAnimation;
    exports.swing = swing;
    exports.tada = tada;
    exports.wobble = wobble;
    exports.zoomIn = zoomIn;
    exports.zoomInDown = zoomInDown;
    exports.zoomInLeft = zoomInLeft;
    exports.zoomInRight = zoomInRight;
    exports.zoomInUp = zoomInUp;
    exports.zoomOut = zoomOut;
    exports.zoomOutDown = zoomOutDown;
    exports.zoomOutLeft = zoomOutLeft;
    exports.zoomOutRight = zoomOutRight;
    exports.zoomOutUp = zoomOutUp;
    exports.ɵa = bounce;
    exports.ɵb = flash;
    exports.ɵba = fadeInRight;
    exports.ɵbb = fadeInRightBig;
    exports.ɵbc = fadeInUp;
    exports.ɵbd = fadeInUpBig;
    exports.ɵbe = fadeOut;
    exports.ɵbf = fadeOutDown;
    exports.ɵbg = fadeOutDownBig;
    exports.ɵbh = fadeOutLeft;
    exports.ɵbi = fadeOutLeftBig;
    exports.ɵbj = fadeOutRight;
    exports.ɵbk = fadeOutRightBig;
    exports.ɵbl = fadeOutUp;
    exports.ɵbm = fadeOutUpBig;
    exports.ɵbn = flip;
    exports.ɵbo = flipInX;
    exports.ɵbp = flipInY;
    exports.ɵbq = flipOutX;
    exports.ɵbr = flipOutY;
    exports.ɵbs = lightSpeedIn;
    exports.ɵbt = lightSpeedOut;
    exports.ɵbu = rotateIn;
    exports.ɵbv = rotateInDownLeft;
    exports.ɵbw = rotateInDownRight;
    exports.ɵbx = rotateInUpLeft;
    exports.ɵby = rotateInUpRight;
    exports.ɵbz = rotateOut;
    exports.ɵc = headShake;
    exports.ɵca = rotateOutDownLeft;
    exports.ɵcb = rotateOutDownRight;
    exports.ɵcc = rotateOutUpLeft;
    exports.ɵcd = rotateOutUpRight;
    exports.ɵce = slideInUp;
    exports.ɵcf = slideInDown;
    exports.ɵcg = slideInLeft;
    exports.ɵch = slideInRight;
    exports.ɵci = slideOutUp;
    exports.ɵcj = slideOutDown;
    exports.ɵck = slideOutLeft;
    exports.ɵcl = slideOutRight;
    exports.ɵcm = zoomIn;
    exports.ɵcn = zoomInDown;
    exports.ɵco = zoomInLeft;
    exports.ɵcp = zoomInRight;
    exports.ɵcq = zoomInUp;
    exports.ɵcr = zoomOut;
    exports.ɵcs = zoomOutDown;
    exports.ɵct = zoomOutLeft;
    exports.ɵcu = zoomOutRight;
    exports.ɵcv = zoomOutUp;
    exports.ɵcw = hinge;
    exports.ɵcx = jackInTheBox;
    exports.ɵcy = rollIn;
    exports.ɵcz = rollOut;
    exports.ɵd = heartBeat;
    exports.ɵda = backInDown;
    exports.ɵdb = backInLeft;
    exports.ɵdc = backInRight;
    exports.ɵdd = backInUp;
    exports.ɵde = backOutDown;
    exports.ɵdf = backOutLeft;
    exports.ɵdg = backOutRight;
    exports.ɵdh = backOutUp;
    exports.ɵe = pulse;
    exports.ɵf = rubberBand;
    exports.ɵg = shake;
    exports.ɵh = swing;
    exports.ɵi = tada;
    exports.ɵj = wobble;
    exports.ɵk = jello;
    exports.ɵl = bounceIn;
    exports.ɵm = bounceInDown;
    exports.ɵn = bounceInLeft;
    exports.ɵo = bounceInRight;
    exports.ɵp = bounceInUp;
    exports.ɵq = bounceOut;
    exports.ɵr = bounceOutDown;
    exports.ɵs = bounceOutLeft;
    exports.ɵt = bounceOutRight;
    exports.ɵu = bounceOutUp;
    exports.ɵv = fadeIn;
    exports.ɵw = fadeInDown;
    exports.ɵx = fadeInDownBig;
    exports.ɵy = fadeInLeft;
    exports.ɵz = fadeInLeftBig;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-animations.umd.js.map
