import { ViewContainerRef, TemplateRef, DoCheck } from '@angular/core';
import { AnimationsService } from '../services/animations.service';
export declare class AnimIfDirective implements DoCheck {
    private templateRef;
    private viewContainer;
    private _animationsService;
    animIfInfo: {
        startAnim: string;
        endAnim: string;
        time: number;
    };
    shownBefore: boolean;
    subscription: any;
    show: any;
    _animIfDirty: any;
    constructor(templateRef: TemplateRef<any>, viewContainer: ViewContainerRef, _animationsService: AnimationsService);
    set animIf(show: boolean);
    /**
     * Applies the changes when needed.
     */
    ngDoCheck(): void;
    private createPlayer;
    private clearAfterTime;
}
