import { AnimationStyleMetadata, AnimationAnimateMetadata } from '@angular/animations';
import { AnimationDefinition } from './animation-definition';
export declare function stylesToAnimation(animationDefinition: AnimationDefinition): (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
export declare const animations: {
    bounce: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flash: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    headShake: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    heartBeat: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    pulse: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rubberBand: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    shake: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    swing: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    tada: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    wobble: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    jello: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceInDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceInLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceInRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceInUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceOutDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceOutLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceOutRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    bounceOutUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInDownBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInLeftBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInRightBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeInUpBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutDownBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutLeftBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutRightBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    fadeOutUpBig: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flip: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flipInX: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flipInY: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flipOutX: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    flipOutY: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    lightSpeedIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    lightSpeedOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateInDownLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateInDownRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateInUpLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateInUpRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateOutDownLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateOutDownRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateOutUpLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rotateOutUpRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideInUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideInDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideInLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideInRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideOutUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideOutDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideOutLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    slideOutRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomInDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomInLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomInRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomInUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomOutDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomOutLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomOutRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    zoomOutUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    hinge: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    jackInTheBox: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rollIn: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    rollOut: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backInDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backInLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backInRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backInUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backOutDown: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backOutLeft: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backOutRight: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
    backOutUp: (number: any) => (AnimationStyleMetadata | AnimationAnimateMetadata)[];
};
